#! /bin/sh
#|  -*-scheme-*-
 exec /usr/bin/mred -u "$0" ${1+"$@"}
 |#

(module virtue-and-virtuality (lib "run.ss" "slideshow")

  (require (lib "code.ss" "slideshow"))
  (require (lib "class.ss"))
  (require (lib "mred.ss" "mred"))

;   (let* ((baphomet (instantiate bitmap% ("baphomet.gif" 'gif #f)))
;          (baph-w   (send baphomet get-width))
;          (baph-h   (send baphomet get-height)) )
;     (set-mystery! (lambda (dc)
;                     (let ((black (make-object color% 0 0 0)))
;                       (let-values (([w h] (send dc get-size)))
;                         (send dc set-background black)
;                         (send dc clear)
;                         (send dc draw-bitmap baphomet
;                               (/ (- w baph-w) 2) (/ (- h baph-h) 2)
;                               'solid black #f) ) ) ) ) )
;   (set-fixed-page! 54)             ;should be timing diagram 3 (nasty)
  
  (slide/title
   "Virtual Hardware"
   (it "or Virtue and Virtuality")
   (blank)
   (blank)
   (blank)
   (blank)
   (blank)
   (t "John Kozak")
   (tt "jk@xylema.org") )


  (slide/title
   "Introduction"
   (page-para "Project of six years ago")
   'next
   (page-para "Source lost")
   'next
   (page-para "All I have is memories")
   'next
   (page-para "Trip around dusty corners")
   'next
   (page-para "like win95, VxDs, parallel ports") )

  (slide/title
   "Problem and Solution"
   (page-item "Problem: how to talk to a non-existent peripheral?")
   'next
   (page-item "Solution: use a non-existent CPU!") 
   'next
   (page-item "Want a scriptable emulator") )
   
   
  (slide/title
   "Emulator Types"
   'next
   (page-item "Hypervisor")
   (page-subitem (it "e.g.") "VM/370, VMware")
   'next
   (page-item "Interpreter")
   (page-subitem (it "e.g.") "bochs, usim")
   'next
   (page-item "Dynamic Translation")
   (page-subitem (it "e.g.") "FX!32, Dynamo") )

  (slide/title
   "Emulator Issues"
   'next
   (page-item "Emulating CPU is relatively easy")
   'next 
   (page-subitem "well and accurately documented")
   'next 
   (page-subitem "(N.B. i386 presents special challenges for hypervisors)")
   'next 
   (page-item "Emulating peripherals can be horrible")
   'next
   (page-subitem "underspecified or mis-implemented")
   'next
   (page-subitem "big variance in implementations") )
  
  (slide/title
   "Emulators: PC on PC"
   'next
   (page-item "VMware")
   (page-subitem "hypervisor")
   (page-subitem "fast, solid")
   (page-subitem "closed, no SDK")
   'next
   (page-item "bochs")
   (page-subitem "interpreter")
   (page-subitem "slower, less stable/complete")
   (page-subitem "free software")
   'next
   (page-item "others?")
   (page-subitem "not then...") 
   )

  (apply slide/title
         "bochs.sf.net Blurb"
         (parameterize ((current-font-size 24))
           (list
            (page-para "Bochs is a highly portable open source IA-32 (x86) PC emulator written in C++, that runs on most popular platforms. It includes emulation of the Intel x86 CPU, common I/O devices, and a custom BIOS. Currently, Bochs can be compiled to emulate a 386, 486, Pentium, Pentium Pro or AMD64 CPU, including optional MMX, SSE, SSE2 and 3DNow instructions.")
            (page-para "Bochs is capable of running most Operating Systems inside the emulation including Linux, Windows 95, DOS, and Windows NT 4. Bochs was written by Kevin Lawton and is currently maintained by this project.")
            (page-para " Bochs can be compiled and used in a variety of modes, some which are still in development. The 'typical' use of bochs is to provide complete x86 PC emulation, including the x86 processor, hardware devices, and memory. This allows you to run OS's and software within the emulator on your workstation, much like you have a machine inside of a machine. For instance, let's say your workstation is a Unix/X11 workstation, but you want to run Win'95 applications. Bochs will allow you to run Win 95 and associated software on your Unix/X11 workstation, displaying a window on your workstation, simulating a monitor on a PC.") ) ) )

  (slide/title
   "bochs - My Views"
   'next
   (page-item "great for systems programming")
   'next
   (page-item "performance not up to all production uses, yet")
   'next
   (page-item "really odd code")
   'next
   (page-subitem (tt ".cc") " files")
   'next
   (page-subitem "premature optimisations `R' us")
   'next
   (page-subitem "bizarre config system")
   'next
   (page-item "very impressive piece of work, but really wants to be a library")
   )

  (slide/title
   "SCM - why?"
   'next
   (page-item "ran on windows with reasonable FFI (SCM/w)")
   'next
   (page-item "clean C/scheme interface")
   (page-subitem "interpreter")
   (page-subitem (tt "setjmp") "/" (tt "longjmp") "and stack-copying")
   (page-subitem "conservative GC")
   (page-subitem "native thread support (avoids " (it "synchromesh") " problem)")
   )

  (slide/title
   "Making bochs Scriptable from SCM"
   'next
   (page-item "disable various bochs optimisations")
   'next
   (page-item "build bochs as a library (DLL)")
   'next
   (page-item "call via FFI")
   )
  
  (slide/title
   "Driving bochs from Scheme"
   (code (define (make-single-byte-device! port name)
           (letrec ((byte   0)
                    (writer (lambda (addr value len)
                              (set! byte value) ))
                    (reader (lambda (addr len)
                              byte)) )
             (register-iowrite-handler writer port name 1)
             (register-ioread-handler reader port name 1) ) )

         #,(t "")
         #,(t "")
         #,(t "")

         (make-single-byte-device! #x180 "demo s/b/d 1")
         (make-single-byte-device! #x181 "demo s/b/d 2") ) )

  (slide/title
   "Other Uses"
   'next
   (page-item "scriptable low-level debugger")
   'next
   (page-item "higher-level logic analyser")
   'next
   (page-item "security analysis")
   'next
   (page-item "fault emulation")
   'next
   (page-item "randomised testing") )

  (slide/title
   "Notations for Hardware"
   (page-item "how to describe hardware?")
   'next
   (page-subitem "VHDL")
   'next
   (page-subitem "various nice formal methods offerings")
   'next
   (page-subitem "timing diagrams are what you get in practice") )
  
  (require "timing-diagram.ss")

  (define *timing-diagram-1* (car (parse-timing-diagram (open-input-file "ieee1284.txt"))))
  
  (slide/title/center
   "Timing Diagrams"
   (dc (lambda (dc dx dy) (draw-timing-diagram *timing-diagram-1* dc dx dy)) 600 200 0 0) )
  
  (define (ascii-art-file->pict filename)
    (apply vl-append line-sep
           (let ((in (open-input-file filename)))
             (let loop ((ans '()))
               (let ((line (read-line in)))
                 (if (eof-object? line)
                     ans
                     (loop (append ans (list (tt line)))) ) ) ) ) ) )

  (define (string-starts-with? s text)
    ;; culled from collects/jk/string.so to avoid loading a .so
    (and (>= (string-length s) (string-length text))
         (equal? (substring s 0 (string-length text)) text) ) )

  (define (ascii-art-file->list-of-pict-lists filename)
    ;; burst an ascii art timing diagram file into one pict-list per name
    (let ((in (open-input-file filename)))
      (let loop ((current '())
                 (ans     '()) )
        (let ((line (read-line in)))
          (cond ((eof-object? line) 
                 `(,@ans (,(apply vl-append line-sep current))) )
                ((string-starts-with? line "name: ")
                 (if (null? current)
                     (loop `(,(tt line)) ans)
                     (loop `(,(tt line))
                           `(,@ans (,(apply vl-append line-sep current))) ) ) )
                (else
                 (loop `(,@current ,(tt line)) ans) ) ) ) ) ) )
  
  (slide/title/center
   "ASCII Art Timing Diagrams"
   'alts
   (ascii-art-file->list-of-pict-lists "ieee1284.txt") )

  (slide/title
   "Working with ASCII Art Timing Diagrams"
   'next
   (page-item "Easy to parse")
   'next
   (page-item "Easy to work with")
   'next
   (page-subitem "emacs mode?")
   'next
   (page-subitem "emacs as logic analyser??")
   'next
   (page-item "Declarative specification of behaviour/protocol")
   'next
   (page-item "Produce pretty pictures via postscript")
   )      
  
  (slide/title
   "Deriving State Machines"
   'next
   (page-para "Each column of a timing diagram defines the state of an interface at a point in time.")
   (page-para "By matching up the initial and final states of each diagram we can build a state machine for the interface.")
   'next
   (page-para "Example here is 'monadic', though")
   )

  (slide/title
   "Inferring Behaviour"
   'next
   (page-item (it "Post hoc, ergo propter hoc"))
   'next
   (page-subitem "Extremely useful principle...")
   'next
   (page-subitem "... as endorsed by David Hume")
   'next
   (page-subitem "Can infer lots about behaviour, but do need to annotate with code.")
   )

  (slide/title
   "Code Annotation for Timing Diagrams"
   'next
   (page-item "glue")
   (page-subitem "to emulated system")
   (page-subitem "to emulated peripheral")
   'next
   (page-item (hc-append (t "1-for-") (it "n")) " cases")
   (page-subitem (it "e.g.") (tt "data") "in previous timing diagrams")
   'next
   (page-item "exceptional conditions")
   (page-subitem (it "e.g.") "timeouts")
   (page-subitem (it "e.g.") "contention on bi-directional line") )

;  (require (prefix qemu: (lib "qemu.ss" "qemu")))
;   (define (left-pad s ch n)
;     (substring (string-append (make-string n ch) s) (string-length s)) )

;   (define *black*    (make-object color%   0 0 0))
;   (define *red*      (make-object color% 255 0 0))
;   (define *lcd-font* (make-object font% 60 "-*-LiquidCrystal" 'decorative 'normal 'bold #f 'default #f))

;   (define 2-lcd% (class canvas%
;                    (inherit get-dc refresh)
;                    (define value 0)
;                    (define/public (set-value! v)
;                      (set! value v)
;                      (refresh) )
;                    (define/public (get-value)
;                      value)
;                    (define/override (on-paint)
;                      (let ((dc (get-dc)))
;                        (send dc set-background      *black*)
;                        (send dc set-text-background *black*)
;                        (send dc set-text-foreground *red*)
;                        (send dc set-font            *lcd-font*)
;                        (send dc clear)
;                        (send dc draw-text
;                              (left-pad (format "~x" value) #\0 2)
;                              10 10 #f 0 0) ) )
;                    (super-instantiate ()) ))

;   (define (go-demo)
;     (let* ((frame (instantiate frame% ("#x80") (min-height 80) (min-width 80)))
;            (2-lcd (instantiate 2-lcd% (frame))) )
      
;       (send frame     show #t)
      
;       (thread (lambda ()
;                 (qemu:startup
;                  (lambda ()
;                    (qemu:register-ioport-read  #x181 1 1
;                                                (lambda (a)
;                                                  (send 2-lcd get-value) ) )
;                    (qemu:register-ioport-write #x80 1 1
;                                                (lambda (a d)
;                                                  (send 2-lcd set-value! d) ) ) ) 
;                  "-cdrom" "fdbootcd.iso") ) ) ) )

  (slide/title
   "Doing It Again Today"
   'next
   (page-item "would probably use:")
   (page-subitem "mzscheme")
   (page-subitem "qemu") )

  (slide/title
   "Last Slide Brought To You By:"
   (parameterize ((current-font-size 22))
     (code (define (go-demo)
             (let* ((frame (instantiate frame% ("#x80") (min-height 80) (min-width 80)))
                    (2-lcd (instantiate 2-lcd% (frame))) )
               (send frame show #t)
               (thread (lambda ()
                         (qemu:startup
                          (lambda ()
                            (qemu:register-ioport-read  #x181 1 1
                                                        (lambda (a)
                                                          (send 2-lcd get-value) ) )
                            (qemu:register-ioport-write #x80 1 1
                                                        (lambda (a d)
                                                          (send 2-lcd set-value! d) ) ) ) 
                          "-cdrom" "fdbootcd.iso") ) ) ) ) ) ) )

  )
